unit EssHtmlReport_DesignTime;

// This unit contains the D5 property editors.
// D6 users may have to edit this unit to use the D6 property editors
// I have added compiler directives for D6, but I do not know if they will have success.
// For help in this transition go to:
// http://community.borland.com/article/0,1410,27717,00.html

interface

uses
  // If problems occur, one idea is to delete all the
  // compiler directives below and let Delphi help you
  // find the correct *.dcu files for your property editors.
  {$IFDEF ver140} // = Delphi 6
  DesignIntf, DesignEditors;   // DesignEditors.dcu may be overkill and might be deleted without problems. 
  {$ELSE} // Delphi <= 5
  DsgnIntf;
  {$ENDIF}

type

  TReportSourceFileName = class(TStringProperty)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
  end;

procedure Register;

implementation

uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
     ESSHtmlReport;

procedure TReportSourceFileName.Edit;
var
  od: TOpenDialog;
begin
  od := TOpenDialog.Create(nil);
  try
    od.DefaultExt := '*.htm';
    od.Filter := 'HTML file (*.htm)|*.htm|Text file (*.txt)|*.txt|Any file (*.*)|*.*';
    od.FileName := GetStrValue;
    if od.Execute then SetStrValue(od.FileName);
  finally
    od.Free;
  end;
end;

function TReportSourceFileName.GetAttributes: TPropertyAttributes;
begin
  Result := inherited GetAttributes + [paDialog];
end;

procedure Register;
begin
  RegisterComponents('ESS', [TESSHtmlReport]);
  RegisterPropertyEditor(TypeInfo(string), TESSHtmlReport, 'ReportSource', TReportSourceFileName);
end;

end.
