unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, OleCtrls, SHDocVw, HTTPApp, DBWeb, ESSHtmlReport, StdCtrls,
  DBCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    ESSHtmlReport1: TESSHtmlReport;
    WebBrowser1: TWebBrowser;
    Table1: TTable;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure ESSHtmlReport1FormatCell(Sender: TObject; CellRow,
      CellColumn: Integer; var BgColor: THTMLBgColor;
      var Align: THTMLAlign; var VAlign: THTMLVAlign; var CustomAttrs,
      CellData: String);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var
  AHtmlFile : OleVariant;
begin
//  ESSHtmlReport1.ReportSource := some file on disk
  AHtmlFile := ExtractFilePath(Application.ExeName) + 'temp.htm';
  Table1.Open;
  ESSHtmlReport1.Content;
  ESSHtmlReport1.PageText.SaveToFile(AHtmlFile);
  Table1.Close;
  WebBrowser1.Navigate2(AHtmlFile);
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  WebBrowser1.Height := Self.Height - 75;
end;

procedure TForm1.ESSHtmlReport1FormatCell(Sender: TObject; CellRow,
  CellColumn: Integer; var BgColor: THTMLBgColor; var Align: THTMLAlign;
  var VAlign: THTMLVAlign; var CustomAttrs, CellData: String);
var
  AFileName, DataString : String;
  AStream : TStream;
  AStream2 : TFileStream;
begin
  IF CellRow = 0 THEN Exit;
  // Use THtml component set (from: http://www.pbear.com) and its OnImageRequest
  // event if you do not want to create files of the image.
  IF EssHtmlReport1.DataSet.Fields[CellColumn].DataType = ftTypedBinary THEN BEGIN
    AFileName := ExtractFilePath(Application.ExeName) + EssHtmlReport1.DataSet.FieldByName('NAME').AsString + '.bmp';
    IF Not FileExists(AFileName) THEN BEGIN
      AStream := EssHtmlReport1.DataSet.CreateBlobStream(EssHtmlReport1.DataSet.Fields[CellColumn], bmRead);
      AStream2 := TFileStream.Create(AFileName, fmCreate OR fmShareDenyWrite);
      TRY
        AStream.Seek(8, soFromBeginning);  // Eliminate the DBase graphic header bits.
        AStream2.CopyFrom(AStream, AStream.Size - 8);
      Finally
        AStream.free;
        AStream2.Free;
      End;
    END;
    CellData := '<img src="' + AFileName + '" width="130" height="88">';
  END;
end;

end.
